'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (name, value) {
    var _this = this;

    return {
        name: name,
        checked: value === undefined ? _getValue2.default.call(this, name, false) : _getValue2.default.call(this, name, []).indexOf(value) > -1,
        //: this::getValue(name, []).includes(value),
        onChange: function onChange(_ref) {
            var _ref$target = _ref.target;
            var checked = _ref$target.checked;
            var type = _ref$target.type;
            return _this.setState(function () {
                var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
                return value === undefined ? _defineProperty({}, name, checked) : _defineProperty({}, name, type === 'checkbox' ? nextMultiValues(checked, state[name], value) : value);
            });
        }
    };
};

var _getValue = require('./getValue');

var _getValue2 = _interopRequireDefault(_getValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var nextMultiValues = function nextMultiValues(checked) {
    var current = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
    var value = arguments[2];
    return checked ? [].concat(_toConsumableArray(current), [value]) : current.filter(function (checked) {
        return checked !== value;
    });
};

// Checkbox
// checkedLink :: ReactInstance => String -> {String name, Boolean checked, Function onChange}
// Radio and Multi-checkbox
// checkedLink :: ReactInstance => (string, String) -> {String name, Boolean checked, Function onChange}