'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

exports.default = function (name) {
    var _this = this;

    return {
        value: _getValue2.default.call(this, name),
        onChange: function onChange(_ref3) {
            var _ref3$target = _ref3.target;
            var multiple = _ref3$target.multiple;
            var options = _ref3$target.options;
            var value = _ref3$target.value;
            return _this.setState(_defineProperty({}, name, multiple ? nextMultiValues(options) : value));
        }
    };
};

var _getValue = require('./getValue');

var _getValue2 = _interopRequireDefault(_getValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var nextMultiValues = function nextMultiValues(options) {
    return [].concat(_toConsumableArray(options)).filter(function (_ref) {
        var selected = _ref.selected;
        return selected;
    }).map(function (_ref2) {
        var value = _ref2.value;
        return value;
    });
};

// Select
// selectedLink :: ReactInstance => String -> {String value, Function onChange}
// Select multiple
// selectedLink :: ReactInstance => String -> {Array value, Function onChange}